#include <math.h>
#include <EEPROM.h>

int trigPin = 12;  //tigg
int echoPin = 13;  //echo
long duration, distance, height, platformat;
const int topswitch = 9;
const int bottomswitch = 10;
const int stepPin = 2; 
const int dirPin = 5; 
boolean cal;
boolean readdata;
boolean starting;
boolean Moveok;
boolean Newperson;

int topswitchval;
int bottomswitchval;
int noofsteps=0;
int curstep=0;
int stepaddress=100;
int UStopaddress=200;
int USbottomaddress=210;
int caladdress=1;
int UStopread=0;
int USbottomread=0;

int UStop=178;  //myheight cm
int USbottom=0; //floor
int steppertop=167; 
int stepperbottom=18;
int calvalue;

String stopfor="Hand"; ///////Head or Hand

void setup() {
  Newperson=true;
  Serial.begin(9600);  
    EEPROM.write(caladdress, 10);
  pinMode(topswitch, INPUT_PULLUP);
  pinMode(bottomswitch, INPUT_PULLUP);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);  
  pinMode(stepPin,OUTPUT); 
  pinMode(dirPin,OUTPUT);  
  calvalue=EEPROM.read(caladdress);
  noofsteps=EEPROM.read(stepaddress);
  noofsteps=noofsteps+EEPROM.read(stepaddress+1);
  UStopread=EEPROM.read(UStopaddress);
  USbottomread=EEPROM.read(USbottomaddress);
  Serial.println(calvalue);
  Serial.println(noofsteps);
  Serial.println(UStopread);
  Serial.println(USbottomread);
  if (calvalue==10){
     cal=false; 
     starting=true;
  }else
  {
    EEPROM.write(stepaddress+1,0);
    EEPROM.write(stepaddress,0);
    cal=true; 
  }
  Serial.println(cal);
}

void loop() {
  if (cal==true)
  {
      topswitchval=digitalRead(topswitch);
      while(topswitchval==HIGH)
      {
        topswitchval=digitalRead(topswitch);
        Moveup();
      }
      Serial.println("Reach Top");
      bottomswitchval=digitalRead(bottomswitch);                
      noofsteps=0;
      while(bottomswitchval==HIGH)
      {
        noofsteps=noofsteps+1;
        bottomswitchval=digitalRead(bottomswitch);                
        Movedown();
      }
      Serial.println(noofsteps);
      if(noofsteps>250)
      {
        EEPROM.write(stepaddress, 250);
        EEPROM.write(stepaddress+1, noofsteps-250);
      }else
      {
        EEPROM.write(stepaddress, noofsteps);
        EEPROM.write(stepaddress+1, 0);        
      }
      Serial.println("Reach Bottom");      
      Serial.println("With no one below the Ultrasonic Click K and send");      
      readdata=false;
      while(readdata==false)
      {
        Distancecal();
        USbottomread=distance;
        if (Serial.available() > 0) {
          char inChar = (char)Serial.read();
          if (inChar="K")
          {
            readdata=true;
            Serial.print("Bottom Read" );    
            Serial.println(USbottomread);    
            EEPROM.write(USbottomaddress, USbottomread);
          }
        }
        delay(50);
      }
      Serial.println("Stand below Ultrasonic Click K and send");      
      readdata=false;
      while(readdata==false)
      {
        Distancecal();
        UStopread=distance;
        if (Serial.available() > 0) {
          char inChar = (char)Serial.read();
          if (inChar="K")
          {
            delay(10000);
            Distancecal();
            Distancecal();
            Distancecal();            
            readdata=true;
            Serial.print("Top Read");    
            Serial.println(UStopread);    
            EEPROM.write(UStopaddress, UStopread);                      
          }
        }
        delay(50);
      }       
      Serial.println("Are You sure Calibration Completed If yes Click Y and else Press any key and enter");      
      readdata=false;
      while(readdata==false)
      {
        if (Serial.available() > 0) {
          char inChar = (char)Serial.read();
          if (inChar=="Y")
          {
            starting=true;
            cal=false;     
            readdata=true;
            EEPROM.write(caladdress, 10);                      
          }else
          {
            cal=true;     
          }
        }              
      }
  } else
  {
    if(starting==true)
    {
      Serial.println("START");
      bottomswitchval=digitalRead(bottomswitch);                
      while(bottomswitchval==HIGH)
      {
        bottomswitchval=digitalRead(bottomswitch);                
        Movedown();
      }
      curstep=noofsteps;      
      Serial.println("Machine ready");
      starting=false;
    }
    Distancecal();
    height=map(distance,USbottomread,UStopread,USbottom,UStop);
    platformat=map(curstep,noofsteps,0,stepperbottom,steppertop);
    Serial.print("Height before");
    Serial.println(height);
    if(height<15){
      Newperson=true;    
    }
    if(stopfor=="Head"){
      height=height-10;
    }else
    {
      height=height*65/100;
    }
    Serial.print("Height after=");
    Serial.print(height);
    Serial.print(" - Platformat=");
    Serial.println(platformat);    
    if(height>30 and Newperson==true){
      Newperson=false;
      Moveok=false;
      if(height-platformat > 10 or height-platformat < -10)
      {   
        if(height>platformat){
          while (Moveok==false)
          {
            curstep=curstep-1;
            Moveup();
            platformat=map(curstep,noofsteps,0,stepperbottom,steppertop);
            Serial.print("Height=");
            Serial.print(height);
            Serial.print(" - Move Platformat=");
            Serial.println(platformat);    
            if(height-platformat <= 0){
              Moveok=true;
            }
          }
        }else
        {
          while (Moveok==false)
          {
            curstep=curstep+1;
            Movedown();
            platformat=map(curstep,noofsteps,0,stepperbottom,steppertop);
            Serial.print("Height=");
            Serial.print(height);
            Serial.print(" - Move Platformat=");
            Serial.println(platformat);                
            if(height-platformat>=0){
              Moveok=true;
            }
          }
        }
      }
    }    
  }
}
void Moveup(){
    topswitchval=digitalRead(topswitch);
    if(topswitchval==HIGH)
    {
        digitalWrite(dirPin,LOW);
        for(int x = 0; x < 50; x++) {
          digitalWrite(stepPin,HIGH);
          delayMicroseconds(500);  
          digitalWrite(stepPin,LOW); 
          delayMicroseconds(500);        
        }           
    }
}
void Movedown(){
  bottomswitchval=digitalRead(bottomswitch);
  if(bottomswitchval==HIGH)
  {
    digitalWrite(dirPin,HIGH);
    for(int x = 0; x < 50; x++) {
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(500);  
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(500);        
    }    
  }      
}
void Distancecal(){
//  duration =0;
//  distance=0;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
//  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
  distance=duration*0.034/2;
  Serial.print("Distance=" );
  Serial.println(distance);
  delay(1000);
}

